package net.shambolica.helperl.pattern.instance;

import com.ericsson.otp.erlang.OtpErlangObject;
import net.shambolica.helperl.pattern.CompositePattern;
import net.shambolica.helperl.pattern.MatchContext;
import net.shambolica.helperl.pattern.Matching;
import net.shambolica.helperl.pattern.OEValueBinder;

/**
 * Match ALL patterns.
 */
public class PAnd extends CompositePattern {

    private final OEValueBinder[] patterns;


    public PAnd(OEValueBinder ... patterns) {
        if (patterns.length == 0) {
            throw new IllegalArgumentException("zero sub-patterns for PAnd");
        }

        this.patterns = patterns;
    }


    @Override
    public boolean bind(OtpErlangObject target, MatchContext context) {
        return Matching.match(target, context, patterns);
    }

}
