package net.shambolica.helperl.pattern.instance;

import com.ericsson.otp.erlang.OtpErlangObject;
import net.shambolica.helperl.pattern.CompositePattern;
import net.shambolica.helperl.pattern.MatchContext;

/**
 * Is the term object an instance of one of these classes?
 */
public class PIsClass extends CompositePattern {
    private final Class<?>[] classes;

    public PIsClass(Class<?>... classes) {
        this.classes = classes;
    }

    @Override
    public boolean bind(OtpErlangObject target, MatchContext context) {
        for (Class<?> c : classes) {
            if (c.isInstance(target)) {
                return true;
            }
        }
        return false;
    }
}
