package net.shambolica.helperl.pattern.instance;

import com.ericsson.otp.erlang.OtpErlangList;
import com.ericsson.otp.erlang.OtpErlangObject;
import net.shambolica.helperl.pattern.CompositePattern;
import net.shambolica.helperl.pattern.MatchContext;
import net.shambolica.helperl.pattern.Matching;
import net.shambolica.helperl.pattern.OEValueBinder;

/**
 * Match a tuple, with constant fields and key bindings.
 */
public class PList extends CompositePattern {

    private final OEValueBinder[] patterns;


    public PList(Object... patterns) {
        this.patterns = Matching.toPatterns(patterns);
    }


    @Override
    public boolean bind(OtpErlangObject target, MatchContext context) {
        if (! (target instanceof OtpErlangList)) {
            return false;
        } else {
            OtpErlangList list = (OtpErlangList) target;
            return list.arity() == patterns.length && Matching.matchAll(list.elements(), context, patterns);
        }
    }

}
