package net.shambolica.helperl.pattern.instance;

import com.ericsson.otp.erlang.OtpErlangObject;
import net.shambolica.helperl.pattern.CompositePattern;
import net.shambolica.helperl.pattern.MatchContext;

/**
 * Match any value, bind a key to it. If key already exists in result
 * with a <b>different</b> value, fail.
 */
public class PSet extends CompositePattern {

    final String key;

    public PSet(String key) {
        this.key = key;
    }

    @Override
    public boolean bind(OtpErlangObject target, MatchContext context) {
        return context.bind(key, target);
    }

}
