package net.shambolica.helperl.pattern.instance;

import com.ericsson.otp.erlang.OtpErlangObject;
import com.ericsson.otp.erlang.OtpErlangTuple;
import net.shambolica.helperl.pattern.CompositePattern;
import net.shambolica.helperl.pattern.MatchContext;
import net.shambolica.helperl.pattern.Matching;
import net.shambolica.helperl.pattern.OEValueBinder;

/**
 * Match a tuple, with constant fields and key bindings.
 */
public class PTuple extends CompositePattern {

    private final OEValueBinder[] patterns;


    public PTuple(Object ... patterns) {
        this.patterns = Matching.toPatterns(patterns);
    }


    @Override
    public boolean bind(OtpErlangObject target, MatchContext context) {
        if (! (target instanceof OtpErlangTuple)) {
            return false;
        } else {
            OtpErlangTuple tuple = (OtpErlangTuple) target;
            return tuple.arity() == patterns.length && Matching.matchAll(tuple.elements(), context, patterns);
        }
    }

}
