package net.shambolica.helperl.pattern.instance;

import com.ericsson.otp.erlang.OtpErlangObject;
import net.shambolica.helperl.pattern.CompositePattern;
import net.shambolica.helperl.pattern.MatchContext;

import static net.shambolica.helperl.util.DataUtils.isEmpty;
import static net.shambolica.helperl.util.DataUtils.trim;

public class PVarPredicate extends CompositePattern {

    private final CompositePattern pred;
    private final String var;

    public PVarPredicate(CompositePattern pred, String var) {
        this.pred = pred;
        var = trim(var);
        if (isEmpty(var)) {
            throw new IllegalArgumentException("empty variable name");
        }

        this.var = var;
    }

    @Override
    public boolean bind(OtpErlangObject target, MatchContext context) {
        return context.hasKey(var) && pred.matches(context.getBinding(var));
    }

}
