package net.shambolica.helperl.util;

import com.ericsson.otp.erlang.*;
import net.shambolica.helperl.conversion.FromObject;

import java.util.ArrayList;
import java.util.Collection;

import static net.shambolica.helperl.conversion.FromObject.asObjectsArray;

public class DataUtils {

    public static String trim(String s) {
        return s == null ? null : s.trim();
    }


    public static boolean isEmpty(String s) {
        return s == null || s.trim().length() == 0;
    }


    public static OtpErlangObject[] toArray(Collection<?> collection) {
        if (collection == null) {
            return null;
        } else {
            return asObjectsArray(new ArrayList<Object>(collection).toArray());
        }
    }


    /**
     * Pads the array with atom("null") where a null appears.
     * @return the array.
     */
    public static OtpErlangObject[] padWithNullAtoms(OtpErlangObject[] objects) {
        if (objects == null) {
            return null;
        } else {
            for (int i = 0 ; i < objects.length ; i++) {
                if (objects[i] == null) {
                    objects[i] = FromObject.nullAtom;
                }
            }
            return objects;
        }
    }


}
